class Graph(object):
    size = 0                                                    #First storage of number of vertices
    adjMatrix = [[0 for x in range(10)] for y in range(10)]     #Creates the matrix

    def __init__(self, size):
        self.size = size
        for i in range(size):
            for j in range(size):
                self.adjMatrix[i][j] = 0                        #Constructs the matrix
        print(self.adjMatrix)

    # methods for (1) adding a vertex;
    def addVertex(self):
        self.size = self.size + 1                       #Increases number of vertices
        for i in range(self.size):
            self.adjMatrix.append([0 for i in range(self.size)])    #Initializes all the elements in the new retex to 0

    # (2) adding an edge;
    def addEdge(self, Vertex1, Vertex2):
        if Vertex1 >= self.size or Vertex2 > self.size: #Checks if the vertex to connect even exists
            print("Vertex doesn't exist.")
        self.adjMatrix[Vertex1][Vertex2] = 1            #Creates an edge by adding 1 to the element of the vertex
        self.adjMatrix[Vertex2][Vertex1] = 1

    # (3) removing an edge;
    def removeEdge(self, v1, v2):
        if self.adjMatrix[v1][v2] == 0:
            print("There is no edge inbetween %d and %d" % (v1, v2)) # I use placeholders in order to return the edges inputed by the user
            return
        self.adjMatrix[v1][v2] = 0                      #Creates new vertex and initializes the new elements to 0
        self.adjMatrix[v2][v1] = 0

    # (4) printing the
    # matrix should appear here
    def display(self):
        print("Adjacency Matrix Graph:")
        print("    ", end="")
        for i in range(0, self.size):                   ##The following code creates the structure of the display how the code is to be shown
                                                        # involved a lot of trial and error
            print(i+1, "",  end="")
        print("\n", "   ", end="")
        for i in range(0, self.size):
            print("--", end="")
        for i in range(0, self.size):
            print()
            print(i+1, "|", end="")
            for j in range(0, self.size):

                print("", self.adjMatrix[i][j], end="") #Displays the values in the matrix to the screen
        print("\n")


# remember list indexing - this is 1 out, unless we start the matrix at 0 (not a +ve integer)
def main():
    g = Graph(6)
    g.display()
    g.addVertex()
    g.addEdge(0, 1)
    g.addEdge(0, 2)
    g.addEdge(1, 2)
    g.addEdge(2, 0)
    g.addEdge(2, 3)
    g.addEdge(0, 4)
    g.addVertex()
    g.display()
    g.removeEdge(2, 3)
    g.display()


if __name__ == '__main__':
    main()
